/*

IFT1169 - Fonctions Amies - Exemple 01 -

01-octobre	- 2016 v1.04	M.Lokbani - GCC 6.2 avec -std=c++11
25-octobre	- 2014 v1.03	M.Lokbani - GCC 4.9.1 avec -std=c++11
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1 avec -std=c++11
21-janvier	- 2006 v1.01	M.Lokbani - GCC3.4.2.
18-octobre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2016 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------
    L'amitié sous tous les angles.
    
    Voir notes de cours, 2: Fonction indépendante amie d'une classe.

*/

#include <iostream>

using namespace std;

class A {
	int i;
	friend void exemple (A&);
public:
	A(int e=100):i(e){}
};

void exemple (A& a) {
	cout << a.i << endl; // accès direct au membre privé i de l'objet a, une instance de la classe A.
}
int main() {
	A y;
	exemple(y);
	return 0;
}


/*

        >amies
        100
        >Exit code: 0

*/
